use config::{Config, File};
use serde::Deserialize;
use std::path::{Path, PathBuf};
use structopt::StructOpt;

#[derive(Debug, StructOpt)]
pub struct Args {
    pub cfg_path: PathBuf,
}

#[derive(Debug, Clone, Deserialize)]
pub struct RaasConfig {
    pub grpc_server: String,
    pub robot_server: String,
}

impl RaasConfig {
    pub fn new(config_path: &Path) -> Result<Self, config::ConfigError> {
        let cfg = Config::builder()
            .add_source(File::from(config_path))
            .build()?;

        cfg.try_deserialize()
    }
}
